import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * AttackerEnemies
 * 
 * @author Jannis
 * @version 1.0
 */
public class AttackerEnemies extends Enemies
{
    private Exhaust exhaust; 
    private boolean smart = Settings.MovingEnemies;
    private Bar bar = null;
    private int time = 3; //idk why but this needs to wait a bit before it can die so the shot can register the touch too
    private int health = Settings.AttackerEnemiesHealth;
    private int attackLevel = 2; //1: they'll just wander /2: sometimes run away /3: PANIC!!!111!1!
    /*
     * Enemy Settings
     */
    private int MaxHealth = Settings.AttackerEnemiesHealth;
    
    
    /**
     * Act - do whatever AttackerEnemies want to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //Ceck for game over
        if ( ! getWorld().getObjects(Button.class).isEmpty() ) return;
        
        // Follow Spaceship if MovingEnemies is enabled, otherwise don't move
        if (smart) {
            move(Settings.AttackerEnemiesSpeed);
            if (isAtEdge()){
                turn(Greenfoot.getRandomNumber(180)+90);
            
            }
            Spaceship sp = getWorld().getObjects(Spaceship.class).get(0);
            turnTowards(sp.getX(), sp.getY());
        }
        
        if (time > 1) {
            time--;
        }
        
        // Update exhaust
        exhaust = moveExhaust(exhaust);
        
        // Update healthbar
        bar = updateHealthBar(bar, MaxHealth, health);
        
        // Check if it has been shot
        ArrayList<Integer> n = touchPlayerShot(time, health, exhaust, bar, Settings.AttackerEnemiesPoints);
        time = n.get(0);
        health = n.get(1);
        
        
    }
    /**
     * This method is called by the Enemies addedToWorld, on object spawn
     */
    @Override
    public void startUpExtras​(World world) {
        // Show exhaust if turned on
        if(Settings.EnemiesHaveExhausts){
            exhaust = new Exhaust();
            getWorld().addObject(exhaust, getX(), getY());
            exhaust.setSpeed(30);
            exhaust.setEngine(true);
            exhaust.setStartSpeed(0);
            exhaust.setColor("Red");
        }  
    }
}
