import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Screen Darkener
 * Is applied to screen when in pause menu or game over screen
 * 
 * @author Jannis Martensen
 * @version 1.0
 */
public class Darkener extends HelperClass
{
    /**
     * This method is called by the Greenfoot system when this actor has been inserted into the world.
     */
    protected void addedToWorld(World world) {
        // Center in world
        setLocation(getWorld().getWidth()/2, getWorld().getHeight()/2);
        
        // Make image the size of the world
        GreenfootImage image = new GreenfootImage(getWorld().getWidth(), getWorld().getHeight());
        
        // Sets the color black and opacity to 150/255
        image.setColor(new Color(0, 0, 0, 150));
        image.fill();
        setImage(image);
    }
}
