import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * EasyEnemies
 * 
 * @author Jannis
 * @version 1.0
 */
public class EasyEnemies extends Enemies
{
    private Exhaust exhaust; 
    private int smoothTurn = 0;
    private int wait = 0;
    private boolean smart = Settings.MovingEnemies;
    private int end = 0;
    private Bar bar = null;
    private int time = 3; //idk why but this needs to wait a bit before it can die so the shot can register the touch too
    private int health = Settings.EasyEnemiesHealth;;
    private int scareLevel = 2; //1: they'll just wander /2: sometimes run away /3: PANIC!!!111!1!
    /*
     * Enemy Settings
     */
    private int MaxHealth = Settings.EasyEnemiesHealth;
    
    
    /**
     * Act - do whatever EasyEnemies wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //Ceck for game over
        if ( ! getWorld().getObjects(Button.class).isEmpty() ) return;
        
        if (smart) {
            move(Settings.EasyEnemiesSpeed);
            if (isAtEdge()){
                turn(Greenfoot.getRandomNumber(180)+90);
            
            }
            // turn 1 at a time instead of instantly turning
            if (smoothTurn > 0) {
                turn(1);
                smoothTurn--;
            } else if (smoothTurn < 0) {
                turn(-1);
                smoothTurn++;
            } else if (wait != 0) {
                wait--;
            } else if (chance(10) && smoothTurn == 0 && wait == 0) {
                // 10% chance to randomly change directions
                smoothTurn = Greenfoot.getRandomNumber(90)-45;
                wait = 25;
            } else if ((chance(1) && smoothTurn == 0 && wait == 0 && scareLevel >= 2) || getNeighbours(150, true, Spaceship.class).size() > 0 && chance(10)) {
                // 1% if scarelevel >= 2 to randomly turn away from the Spaceship, if the spaceship is nearby the chance increases to 10%
                Spaceship sp = getWorld().getObjects(Spaceship.class).get(0);
                turnTowards(sp.getX(), sp.getY());
                turn(180);
                wait = 25;
            } else if (chance(3) &&  smoothTurn  == 0 && wait == 0 && scareLevel == 3) {
                // 3% chance if scareLevel == 3 to turn away from the Spaceship
                Spaceship sp = getWorld().getObjects(Spaceship.class).get(0);
                turnTowards(sp.getX(), sp.getY());
                turn(180);
                wait = 25;
            }
        }
        if (time > 1) {
            time--;
        }
        if (end > 0) {
            end--;
        }
        
        // Spawn a Playershot if beeing touched by the Spaceship
        if (touch(Spaceship.class) && end == 0) {
            end = 150;
            Shots actor = new Shots(0, true, 1);
            actor.setColor(Settings.SpaceshipShotsColor);
            getWorld().addObject(actor, getX(), getY());
        }
        
        // Update exhaust
        exhaust = moveExhaust(exhaust);
        
        // Update healthbar
        bar = updateHealthBar(bar, MaxHealth, health);
        
        
        // Check if it has been shot
        ArrayList<Integer> n = touchPlayerShot(time, health, exhaust, bar, Settings.EasyEnemiesPoints);
        time = n.get(0);
        health = n.get(1);
    }
    /**
     * This method is called by the Enemies addedToWorld, on object spawn
     */
    @Override
    public void startUpExtras​(World world) {
        // Show exhaust if turned on
        if(Settings.EnemiesHaveExhausts){
            exhaust = new Exhaust();
            getWorld().addObject(exhaust, getX(), getY());
            exhaust.setSpeed(30);
            exhaust.setEngine(true);
            exhaust.setStartSpeed(0);
        }
        
        // Set Random Color and Show exhaust if turned on
        int Image = Greenfoot.getRandomNumber(5);
        if (Image == 0) {
            setImage("enemy(blue).png");
            if(Settings.EnemiesHaveExhausts){exhaust.setColor("Blue");}
        } else if (Image == 1) {
            setImage("enemy(red).png");
            if(Settings.EnemiesHaveExhausts){exhaust.setColor("Red");}
        } else if (Image == 2) {
            setImage("enemy(green).png");
            if(Settings.EnemiesHaveExhausts){exhaust.setColor("Green");}
        } else {
            setImage("enemy(purple).png");
            if(Settings.EnemiesHaveExhausts){exhaust.setColor("Purple");}
        }
        
        imageSize(-10);
    }
}
