import greenfoot.*;
import java.util.ArrayList;
import java.io.*;
import java.util.Arrays;
import java.util.Set;
import java.util.TreeSet;
import java.util.Collections;
/**
 * SaveFileSelector
 * 
 * @author Jannis Martensen
 * @version 1.0
 */
public class ScoreboardScreen extends WorldHelper
{
    private Scroller scroller;
    Label level;
    Button settings;
    Image t;
    ArrayList<File> filesList = new ArrayList<>();
    ArrayList<Button> labelList = new ArrayList<>();
    int StartM = 2; // m is a value for how far down an object should be placed
    int overallM = 0;
    int m = StartM;
    int max = 0;
    int max1 = 0;
    int max2 = 0;
    int max3 = 0;
    int max4 = 0;
    int distance = 75;
    Button customEntry = null;
    ArrayList<Object> a = new ArrayList<>();
    /**
     * @param l: load mode or not (save mode)
     */
    public ScoreboardScreen()
    {
             
        // Display scroll key help
        t = new Image();
        t.setImage("anleitungScroll.png");
        addObject(t, getWidth()/15, getHeight()/2);
        
        // Title and back button
        if (Settings.Language.equals("en")) {
            settings = new Button("Back", 1);
            addObject(settings, getWidth()-120, getHeight()-50);
        } else if (Settings.Language.equals("de")) {
            settings = new Button("Zurück", 1);
            addObject(settings, getWidth()-120, getHeight()-50);
        }
        level = new Label("Scoreboard", 50);
        addObject(level, getWidth()/2, 40);
        
        
        
        // Add the buttons for all scoreboards, but make them unclickable
        Set<String> keys1 = Settings.ScoreList.keySet();
        
        // TreeSet sort alphabetically
        TreeSet<String> keys = new TreeSet<>();
        keys.addAll(keys1);
         
        int i = 1;
        for (String lvl : keys) {
            // Level Name Button
            Button b = new Button(lvl, 50);
            b.deactivate();
            b.setRounded(false);
            GreenfootImage image = b.getImage();
            image.setTransparency(255);
            b.setImage(image);
            labelList.add(b);
            a.add(b);
            addObject(b, (int)(getWidth()/5*i), (int)(distance*m));
            
            // Save x/y values for easier usage when scrolling
            b.setPosition((int)(distance*m));
            b.setXPosition((int)(getWidth()/5*i));
            
            // Add one to m to set the next button 1 distance below
            m++;
            
            // Get the list of scores for the current level and sort them
            ArrayList<Integer> values = Settings.ScoreList.get(lvl);
            Collections.sort(values);
            Collections.reverse(values);
            for (Integer lvlp : values) {
                // Deactivated Buttons for the individual values
                Button p = new Button(lvlp.toString(), 40);
                p.deactivate();
                p.setRounded(false);
                GreenfootImage image2 = p.getImage();
                image2.setTransparency(255);
                p.setImage(image2);

                labelList.add(p);
                a.add(p);
                addObject(p, (int)(getWidth()/5*i), (int)(distance*m));
                
                // Save x/y values for easier usage when scrolling
                p.setPosition((int)(distance*m));
                p.setXPosition((int)(getWidth()/5*i));
                
                // Add one to m to set the next button 1 distance below
                m++;
                
            }
            // remove one from m to spawn the next level closer to the one above it
            m--;
            
            // Set the maximum m value of the ScrollScreen
            if (m > max1 && i == 1) max1 = m;
            if (m > max2 && i == 2) max2 = m;
            if (m > max3 && i == 3) max3 = m;
            if (m > max4 && i == 4) max4 = m;
            
            if (m > max) {max = m;}
            // After 4 scoreboards were in a row, make the next one go one down under the furtherst m value button
            if (i == 4) { 
                // Get the lowest reaching scoreboard and place the next scoreboard under it
                if (max1 <= max2 && max1 <= max3 && max1 <= max4) {
                    overallM = max1; 
                    i = 1;
                } else if (max2 <= max1 && max2 <= max3 && max2 <= max4) {
                    overallM = max2;
                    i = 2;
                } else if (max3 <= max1 && max3 <= max2 && max3 <= max4) {
                    overallM = max3;
                    i = 3;
                } else if (max4 <= max1 && max4 <= max3 && max4 <= max2) {
                    overallM = max4; 
                    i = 4;
                }
                
                m = overallM + StartM;
            }
            // Reset m to start of line and spawn next scoreboard to the right of the last one
            else {i++; m = overallM + StartM;}
        }
       
        int d;
        // Set worldheight based on list length
        if ((max+StartM)*distance > getHeight()) {d = (max+StartM+1)*distance;} else {d = getHeight();}
        
        
        // Scroller class
        scroller = new Scroller(this, new GreenfootImage("background.jpg"), getWidth(), d);
        
        m = StartM;
    }
    
    /**
     * Handles scrolling, showing/hiding objects and pressing buttons
     */
    public void act()
    {
        // Navigate back to the Title Menu
        if (Greenfoot.mouseClicked(settings) || Greenfoot.isKeyDown("escape")) {
            Greenfoot.delay(50);
            Greenfoot.setWorld(new TitleScreen());
        }
        
        // Scroll world
        if (Greenfoot.isKeyDown("up")) {
            scrollUp();
        } else if(Greenfoot.isKeyDown("down")) {
            scrollDown();
        }
        
        
        // Keep static elements in the same position
        // level.setLocation(getWidth()/2, 40);
        //settings.setLocation(getWidth()-120, getHeight()-50);
        // t.setLocation(getWidth()/15, getHeight()/2);
        
        // Iterate through all buttons and get click state and set visibility according to position
        for (int i = 0; i < labelList.size(); i++) {
            Button button = labelList.get(i);
            int threshTop = 100;// custom threshold to not collide with the top Text
            int ButtonPosition = button.getPosition();
            int ButtonXPosition = button.getXPosition();
            int scrollDistance = scroller.getScrolledY() + threshTop; 
            int scrollScreenEnd = scrollDistance-threshTop+getHeight();
            
            // If Buttons outside of scroll, hide it
            if ((scrollDistance >= ButtonPosition || ButtonPosition >= scrollScreenEnd) && button.getImage().getTransparency() != 0) {
                GreenfootImage image = button.getImage();
                image.setTransparency(0);
                button.setImage(image);
                
            } else if (scrollDistance < ButtonPosition && ButtonPosition < scrollScreenEnd && button.getImage().getTransparency() == 0) {
                // If the button position is visible in current scrollscreen, show and correctly position it
                
                // If button position is nearer to the bottom spawn at the bottom and spawn at the top if closer to the top
                if (scrollScreenEnd - ButtonPosition < ButtonPosition - scrollDistance) {
                    // If the button position is closer to the top or bottom
                    button.setLocation(ButtonXPosition, getHeight()-1); 
                } else {
                    button.setLocation(ButtonXPosition, 1+threshTop);   
                }
                GreenfootImage image = button.getImage();
                image.setTransparency(255);
                button.setImage(image);
            }
        }
    }
    private void scrollDown() {
        scroller.scroll(0, 2, a, true);
    }
    private void scrollUp() {
        scroller.scroll(0, -2, a, true);
    }
}
