import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
/**
 * TitleScreen
 * 
 * @author Jannis Martensen
 * @version 1.0
 */
public class TitleScreen extends WorldHelper
{

    private int Counter;
    private Image i;
    private Image j;
    private Button asteroids;
    private Button followers;
    private Button BattleForEarth;
    private Button battleOfTwilightGap;
    private Button HelmsDeep;
    private Button battleOfTheCity;
    // private Button TemplateLevel;
    private Button boss;

    // Spaceship Colors
    private Button scblack;
    private Button scblue;
    private Button scgreen;
    private Button scnormal;
    private Button scpink;
    private Button scpurple;
    private Button scwhite;
    private Button scyellow;

    // Exhaust Colors
    private Button ecgreen;
    private Button ecpink;
    private Button ecred;
    private Button ecyellow;
    private Button ecorange;
    private Button ecpurple;
    private Button ecblue;
    private Button ecwhite;

    // Projectile Colors
    private Button pcgreen;
    private Button pcpink;
    private Button pcred;
    private Button pcyellow;
    private Button pcorange;
    private Button pcpurple;
    
    
    // Other Buttons
    private Button selectLanguage;
    private Button settings;
    private Button score;
    private Button ApplySkinTo;
    
    private int am = 100;

    private Scroller scroller;
    private ArrayList<Object> a = new ArrayList<>();
    int StartM = 2;
    int m = StartM;
    int distance = 75;
    Image t;
    
    /**
     * Constructor for objects of class TitleScreen.
     */
    public TitleScreen() 
    {
        prepare();
    }
    
    public TitleScreen(String p) 
    {
        prepare();
        if (Settings.TwoPlayerMode) {
            ApplySkinTo.setText(p);
        }
    }
    
    public void prepare() {
        //setWorldColor(15, 15, 15, 255);
        // Spawn the target to test projectiles and make it invincible
        BossEnemies b = new BossEnemies(true);
        addObject(b, 1, 1);
        b.setLocation((int)(getWidth()/2.0), (int)(getHeight()/5.0)+am);
        b.setRotation(0);

        // Spawn the movement Instructions
        i = new Image();
        if (Settings.CanMoveBackward) {
            i.setImage("anleitung.png");
        } else {
            i.setImage("anleitung(noBackwards).png");
        }
        
        // If the sub menu text isn't shown, recenter the objects
        if (!Settings.ShowChooseText) {
            am = 50;
        }
        
        ApplySkinTo = new Button("Player1", 1);
        
        if (Settings.TwoPlayerMode) {
            addObject(i, (int)((double)getWidth()/3.0 * 1.29), getHeight()/2+35);
            j = new Image();
            if (Settings.CanMoveBackward) {
                j.setImage("anleitungPlayer2.png");
            } else {
                j.setImage("anleitungPlayer2(noBackwards).png");
            }
            addObject(j, (int)((double)getWidth()/3.0 * 1.71), getHeight()/2+38);
            addObject(ApplySkinTo, (int)(getWidth()/4.0*3), (int)(getHeight()/5.0)+am+65);
        } else {
            addObject(i, getWidth()/2+3, getHeight()/2+35);
        }

        //Level select Buttons
        if (Settings.Language.equals("en") && Settings.ShowChooseText) {
            addObject(new Label("Select a Level:", 50), (int)(getWidth()/4.0), (int)(getHeight()/5.0)+am);
        } else if (Settings.Language.equals("de") && Settings.ShowChooseText) {
            addObject(new Label("Wähle ein Level aus:", 50), (int)(getWidth()/4.0), (int)(getHeight()/5.0)+am);
        }
        
        m+=2;
        if (Settings.Language.equals("en")) {
            asteroids = new Button("Asteroids", 1);
            addObject(asteroids, (int)(getWidth()/4.0), (int)((m)*distance)+am+50);
        } else if (Settings.Language.equals("de")) {
            asteroids = new Button("Asteroide", 1);
            addObject(asteroids, (int)(getWidth()/4.0), (int)((m)*distance)+am+50);
        }
        a.add(asteroids);
        if (!Settings.AsteroidsUnlocked && !Settings.UnlockAll) asteroids.deactivate();
        m++;
        
        if (Settings.Language.equals("en")) {
            followers = new Button("Followers", 2);
            addObject(followers, (int)(getWidth()/4.0), (int)((m)*distance)+am+50);
        } else if (Settings.Language.equals("de")) {
            followers = new Button("Verfolgt", 2);
            addObject(followers, (int)(getWidth()/4.0), (int)((m)*distance)+am+50);
        }
        a.add(followers);
        if (!Settings.FollowersUnlocked && !Settings.UnlockAll) followers.deactivate();
        m++;
        
        BattleForEarth = new Button("Battle for Earth", 2);
        addObject(BattleForEarth, (int)(getWidth()/4.0), (int)(((m)*distance))+am+50);
        a.add(BattleForEarth);
        if (!Settings.BattleForEarth && !Settings.UnlockAll) BattleForEarth.deactivate();
        m++;
        
        
        battleOfTwilightGap = new Button("Battle of Twilight Gap", 2);
        addObject(battleOfTwilightGap, (int)(getWidth()/4.0), (int)((m)*distance)+am+50);
        a.add(battleOfTwilightGap);
        if (!Settings.BattleOfTwilightGap && !Settings.UnlockAll) battleOfTwilightGap.deactivate();
        m++;
        
        
        HelmsDeep = new Button("Helm's Deep", 2);
        addObject(HelmsDeep, (int)(getWidth()/4.0), (int)(((m)*distance))+am+50);
        a.add(HelmsDeep);
        if (!Settings.HelmsDeep && !Settings.UnlockAll) HelmsDeep.deactivate();
        m++;
        
        battleOfTheCity = new Button("Battle of the City", 2);
        addObject(battleOfTheCity, (int)(getWidth()/4.0), (int)(((m)*distance))+am+50);
        a.add(battleOfTheCity);
        if (!Settings.BattleOfTheCity && !Settings.UnlockAll) battleOfTheCity.deactivate();
        m++;
        
        boss = new Button("   Boss   ", 3);
        addObject(boss, (int)(getWidth()/4.0), (int)((m)*distance)+am+50);
        a.add(boss);
        if (!Settings.BossUnlocked && !Settings.UnlockAll) boss.deactivate();
        

        // Display scroll key help
        t = new Image();
        t.setImage("anleitungScroll.png");
        
        
        // Color select Buttons
        if (Settings.Language.equals("en") && Settings.ShowChooseText) {
            addObject(new Label("Select your looks:", 50), (int)(getWidth()/4.0*3), (int)(getHeight()/5.0)+am);
        } else if (Settings.Language.equals("de") && Settings.ShowChooseText) {
            addObject(new Label("Wähle dein Aussehen:", 50), (int)(getWidth()/4.0*3), (int)(getHeight()/5.0)+am);
        }

        spaceshipColor();
        exhaustColor();
        projectileColor();
        
        // Goto SettingsScreen if shown
        if (Settings.Language.equals("en") && Settings.ShowSettingsOption) {
            settings = new Button("Settings", 1);
            addObject(settings, getWidth()-120, getHeight()-50);
        } else if (Settings.Language.equals("de") && Settings.ShowSettingsOption) {
            settings = new Button("Einstellungen", 1);
            addObject(settings, getWidth()-150, getHeight()-50);
        }
        
        // Scoreboard
        score = new Button("Scoreboard", 1);
        addObject(score, getWidth()/2, getHeight()-50);
         

        // Language select Button
        if (Settings.ShowSettingsOption) {
            selectLanguage = new Button(Settings.Language.toUpperCase(), 1);
            addObject(selectLanguage, 80, getHeight()-50);
        } else {
            selectLanguage = new Button(Settings.Language.toUpperCase(), 1);
            addObject(selectLanguage, getWidth()-80, getHeight()-50);
        }
        
        int d;
        // Set worldheight based on list length
        if (m*distance > getHeight()/2) {
            d = (a.size()+StartM+1)*distance + getHeight()/3;
            
            /* Show scroll help if needed */
            addObject(t, getWidth()/10, getHeight()/5*3);
        } else {
            d = getHeight();
        }
        
        // Scroller class
        scroller = new Scroller(this, new GreenfootImage("background.jpg"), getWidth(), d);
        
        // Act once to hide level buttons that shouldn't be visible
        act();
        
        // Spawn spaceship
        if (Settings.TwoPlayerMode) {
            addObject(new Spaceship(1), (int)((double)getWidth()/3.0 * 1.29)-4, getHeight()/2);
            addObject(new Spaceship(2), (int)((double)getWidth()/3.0 * 1.71)-4, getHeight()/2+3);
        } else {
            addObject(new Spaceship(1), getWidth()/2, getHeight()/2);
        }
        // Spawn Title text
        Image level = new Image();
        addObject(level, getWidth()/2, 120);
    }
    /**
     * Act - do whatever the Level Asteroids wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act(){
        //removeObject(i);
        
        // Register Button clicks on level select
        if (Greenfoot.mouseClicked(asteroids) && (Settings.AsteroidsUnlocked || Settings.UnlockAll)){
            Greenfoot.setWorld(new Level(15, 7, 0, 0,"Asteroids", "Asteroide"));
        } else if (Greenfoot.mouseClicked(followers) && (Settings.FollowersUnlocked || Settings.UnlockAll)) {
            Greenfoot.setWorld(new Level(10, 5, 1, 0,"Followed", "Verfolgt"));
        } else if (Greenfoot.mouseClicked(BattleForEarth) && (Settings.BattleForEarth || Settings.UnlockAll)) {
            Greenfoot.setWorld(new Level(20, 3, 1, 0,"Battle for Earth", "Kampf um die Erde"));
        } else if (Greenfoot.mouseClicked(battleOfTwilightGap) && (Settings.BattleOfTwilightGap || Settings.UnlockAll)) {
            Greenfoot.setWorld(new Level(10, 7, 2, 0,"Battle of Twilight Gap", "Kampf von Twilight Gap"));
        } else if (Greenfoot.mouseClicked(HelmsDeep) && (Settings.HelmsDeep || Settings.UnlockAll)) {
            Greenfoot.setWorld(new Level(15, 5, 1, 0,"Helm's Deep", "Helm's Tief"));
        } else if (Greenfoot.mouseClicked(battleOfTheCity) && (Settings.BattleOfTheCity || Settings.UnlockAll)) {
            Greenfoot.setWorld(new Level(15, 3, 2, 0,"Battle of the City", "Kampf um die Stadt"));
        } else if (Greenfoot.mouseClicked(boss) && (Settings.BossUnlocked || Settings.UnlockAll)) {
            Greenfoot.setWorld(new Level(10, 0, 0, 1,"Boss", "Boss"));
        }

        // Scroll world
        if (Greenfoot.isKeyDown("up")) {
            scrollUp();
        } else if(Greenfoot.isKeyDown("down")) {
            scrollDown();
        }
        
        // Change Language Button
        if (Greenfoot.mouseClicked(selectLanguage) && Settings.Language.equals("en")) {
            selectLanguage.setText("DE");
            Settings.Language = "de";
            Greenfoot.setWorld(new TitleScreen());
        } else if (Greenfoot.mouseClicked(selectLanguage) && Settings.Language.equals("de")) {
            selectLanguage.setText("EN");
            Settings.Language = "en";
            Greenfoot.setWorld(new TitleScreen());
        }
        
        // Goto SettingScreen
        if (Settings.ShowSettingsOption) {
            if (Greenfoot.mouseClicked(settings)) {
                Greenfoot.setWorld(new SettingsScreen());
            }
        }
        
        // Goto Scoreboard
        
        if (Greenfoot.mouseClicked(score)) {
            Greenfoot.setWorld(new ScoreboardScreen());
        }
        
        spaceshipSelector();
        exhaustSelector();
        projectileSelector();
        
        if (Settings.TwoPlayerMode) {
            if (Greenfoot.mouseClicked(ApplySkinTo) && ApplySkinTo.getText() == "Player1") {
                ApplySkinTo.setText("Player2");
            } else if (Greenfoot.mouseClicked(ApplySkinTo) && ApplySkinTo.getText() == "Player2") {
                ApplySkinTo.setText("Player1");
            }
        }
        
        for (int i = 0; i < a.size(); i++) {
            Actor obj = (Actor) a.get(i);
            int threshTop = 250;// custom threshold to not collide with the top Text
            int threshBottom = 250;// custom threshold to not collide with the bottom Text
            int objPosition = (StartM+2 + i) * distance;
            int scrollDistance = scroller.getScrolledY() + threshTop; 
            int scrollScreenEnd = scrollDistance-threshTop+getHeight()-threshBottom;
            
            // If Buttons outside of scroll, hide it
            if ((scrollDistance >= objPosition || objPosition >= scrollScreenEnd) && obj.getImage().getTransparency() != 0) {
                GreenfootImage image = obj.getImage();
                image.setTransparency(0);
                obj.setImage(image);
                
            } else if (scrollDistance < objPosition && objPosition < scrollScreenEnd && obj.getImage().getTransparency() == 0) {
                // If the button position is visible in current scrollscreen, show and correctly position it
                
                // If button position is nearer to the bottom spawn at the bottom and spawn at the top if closer to the top
                if (scrollScreenEnd - objPosition < objPosition - scrollDistance) {
                    // If the button position is closer to the top or bottom
                    obj.setLocation((int)(getWidth()/4), getHeight()-threshBottom-1+am+50); 
                } else {
                    obj.setLocation((int)(getWidth()/4), 1+threshTop+am+50);   
                }
                GreenfootImage image = obj.getImage();
                image.setTransparency(200);
                obj.setImage(image);
            }
        }
        
    }
    private void scrollDown() {
        scroller.scroll(0, 2, a, false);
    }
    private void scrollUp() {
        scroller.scroll(0, -2, a, false);
    }
    /**
     * Register clicks on Spaceship color selections
     */
    public void spaceshipSelector() {
        //Spaceship Colors
        if (ApplySkinTo.getText().equals("Player1")) {
            if (Greenfoot.mouseClicked(scblack)){Settings.SpaceshipColor = "Black"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scblue)){Settings.SpaceshipColor = "Blue"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scgreen)){Settings.SpaceshipColor = "Green"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scnormal)){Settings.SpaceshipColor = "Normal"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scpink)){Settings.SpaceshipColor = "Pink"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scpurple)){Settings.SpaceshipColor = "Purple"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scwhite)){Settings.SpaceshipColor = "White"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(scyellow)){Settings.SpaceshipColor = "Yellow"; Greenfoot.setWorld(new TitleScreen());}       
        } else if (ApplySkinTo.getText().equals("Player2")) {
            if (Greenfoot.mouseClicked(scblack)){Settings.Spaceship2Color = "Black"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scblue)){Settings.Spaceship2Color = "Blue"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scgreen)){Settings.Spaceship2Color = "Green"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scnormal)){Settings.Spaceship2Color = "Normal"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scpink)){Settings.Spaceship2Color = "Pink"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scpurple)){Settings.Spaceship2Color = "Purple"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scwhite)){Settings.Spaceship2Color = "White"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(scyellow)){Settings.Spaceship2Color = "Yellow"; Greenfoot.setWorld(new TitleScreen("Player2"));}
        }
    }
    /**
     * Register clicks on Spaceship Exhaust color selections
     */
    public void exhaustSelector() {
        //Exhaust Colors
        if (ApplySkinTo.getText().equals("Player1")) {
            if (Greenfoot.mouseClicked(ecgreen)){Settings.SpaceshipExhaustColor = "Green"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecpink)){Settings.SpaceshipExhaustColor = "Pink"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecred)){Settings.SpaceshipExhaustColor = "Red"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecyellow)){Settings.SpaceshipExhaustColor = "Yellow"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecorange)){Settings.SpaceshipExhaustColor = "Orange"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecpurple)){Settings.SpaceshipExhaustColor = "Purple"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecblue)){Settings.SpaceshipExhaustColor = "Blue"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(ecwhite)){Settings.SpaceshipExhaustColor = "White"; Greenfoot.setWorld(new TitleScreen());}
        } else if (ApplySkinTo.getText().equals("Player2")) {
            if (Greenfoot.mouseClicked(ecgreen)){Settings.Spaceship2ExhaustColor = "Green"; Greenfoot.setWorld(new TitleScreen("Player2"));}        
            if (Greenfoot.mouseClicked(ecpink)){Settings.Spaceship2ExhaustColor = "Pink"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(ecred)){Settings.Spaceship2ExhaustColor = "Red"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(ecyellow)){Settings.Spaceship2ExhaustColor = "Yellow"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(ecorange)){Settings.Spaceship2ExhaustColor = "Orange"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(ecpurple)){Settings.Spaceship2ExhaustColor = "Purple"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(ecblue)){Settings.Spaceship2ExhaustColor = "Blue"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(ecwhite)){Settings.Spaceship2ExhaustColor = "White"; Greenfoot.setWorld(new TitleScreen("Player2"));}
        }
    }
    /**
     * Register clicks on Spaceship projectile color selections
     */
    public void projectileSelector() {
        //Projectile Colors
        if (ApplySkinTo.getText().equals("Player1")) {
            if (Greenfoot.mouseClicked(pcgreen)){Settings.SpaceshipShotsColor = "Green"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(pcpink)){Settings.SpaceshipShotsColor = "Pink"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(pcred)){Settings.SpaceshipShotsColor = "Red"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(pcyellow)){Settings.SpaceshipShotsColor = "Yellow"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(pcorange)){Settings.SpaceshipShotsColor = "Orange"; Greenfoot.setWorld(new TitleScreen());}
            if (Greenfoot.mouseClicked(pcpurple)){Settings.SpaceshipShotsColor = "Purple"; Greenfoot.setWorld(new TitleScreen());}
        } else if (ApplySkinTo.getText().equals("Player2")) {
            if (Greenfoot.mouseClicked(pcgreen)){Settings.Spaceship2ShotsColor = "Green"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(pcpink)){Settings.Spaceship2ShotsColor = "Pink"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(pcred)){Settings.Spaceship2ShotsColor = "Red"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(pcyellow)){Settings.Spaceship2ShotsColor = "Yellow"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(pcorange)){Settings.Spaceship2ShotsColor = "Orange"; Greenfoot.setWorld(new TitleScreen("Player2"));}
            if (Greenfoot.mouseClicked(pcpurple)){Settings.Spaceship2ShotsColor = "Purple"; Greenfoot.setWorld(new TitleScreen("Player2"));}
        }
    }
    /**
     * Add Buttons for Spaceship color selections
     */
    public void spaceshipColor(){
        if (Settings.Language.equals("en")) {
            Label sc = new Label("Spaceship Color:", 40);
            addObject(sc, (int)(getWidth()/4.0*3), (int)(getHeight()/3.0)+am);
        } else if (Settings.Language.equals("de")) {
            Label sc = new Label("Raumschifffarbe:", 40);
            addObject(sc, (int)(getWidth()/4.0*3), (int)(getHeight()/3.0)+am);
        }

        // Spaceship color (Black, Blue, Green, Normal, Pink, Purple, White, Yellow)

        scblack = new Button("", 1);
        scblack.setButtonColor(Color.BLACK);
        scblack.setFrameColor(Color.WHITE);
        addObject(scblack, (int)(getWidth()/4.0*3)+25, (int)(getHeight()/3.0)+50+am);

        scblue = new Button("", 1);
        scblue.setButtonColor(Color.BLUE);
        scblue.setFrameColor(Color.WHITE);
        addObject(scblue, (int)(getWidth()/4.0*3)-25, (int)(getHeight()/3.0)+50+am);

        scgreen = new Button("", 1);
        scgreen.setButtonColor(Color.GREEN);
        scgreen.setFrameColor(Color.WHITE);
        addObject(scgreen, (int)(getWidth()/4.0*3)+75, (int)(getHeight()/3.0)+50+am);

        scnormal = new Button("", 1);
        scnormal.setButtonColor(Color.ORANGE);
        scnormal.setFrameColor(Color.WHITE);
        addObject(scnormal, (int)(getWidth()/4.0*3)-75, (int)(getHeight()/3.0)+50+am);

        scpink = new Button("", 1);
        scpink.setButtonColor(Color.PINK);
        scpink.setFrameColor(Color.WHITE);
        addObject(scpink, (int)(getWidth()/4.0*3)+125, (int)(getHeight()/3.0)+50+am);

        scpurple = new Button("", 1);
        scpurple.setButtonColor(Color.MAGENTA);
        scpurple.setFrameColor(Color.WHITE);
        addObject(scpurple, (int)(getWidth()/4.0*3)-125, (int)(getHeight()/3.0)+50+am);

        scwhite = new Button("", 1);
        scwhite.setButtonColor(Color.WHITE);
        scwhite.setFrameColor(Color.WHITE);
        addObject(scwhite, (int)(getWidth()/4.0*3)+175, (int)(getHeight()/3.0)+50+am);

        scyellow = new Button("", 1);
        scyellow.setButtonColor(Color.YELLOW);
        scyellow.setFrameColor(Color.WHITE);
        addObject(scyellow, (int)(getWidth()/4.0*3)-175, (int)(getHeight()/3.0)+50+am);

    }
    /**
     * Add Buttons for Spaceship exhaust color selections
     */
    public void exhaustColor(){
        if (Settings.Language.equals("en")) {
            Label ec = new Label(" Exhaust Color: ", 40);
            addObject(ec, (int)(getWidth()/4.0*3), (int)(getHeight()/2.0)+am);
        } else if (Settings.Language.equals("de")) {
            Label ec = new Label(" Auspufffarbe: ", 40);
            addObject(ec, (int)(getWidth()/4.0*3), (int)(getHeight()/2.0)+am);
        }

        // Spaceship exhaust (Green, Pink, Red, Yellow, Orange, Purple, Blue, White)
        ecred = new Button("", 1);
        ecred.setButtonColor(Color.RED);
        ecred.setFrameColor(Color.WHITE);
        addObject(ecred, (int)(getWidth()/4.0*3)+25, (int)(getHeight()/2.0)+50+am);

        ecblue = new Button("", 1);
        ecblue.setButtonColor(Color.BLUE);
        ecblue.setFrameColor(Color.WHITE);
        addObject(ecblue, (int)(getWidth()/4.0*3)-25, (int)(getHeight()/2.0)+50+am);

        ecgreen = new Button("", 1);
        ecgreen.setButtonColor(Color.GREEN);
        ecgreen.setFrameColor(Color.WHITE);
        addObject(ecgreen, (int)(getWidth()/4.0*3)+75, (int)(getHeight()/2.0)+50+am);

        ecorange = new Button("", 1);
        ecorange.setButtonColor(Color.ORANGE);
        ecorange.setFrameColor(Color.WHITE);
        addObject(ecorange, (int)(getWidth()/4.0*3)-75, (int)(getHeight()/2.0)+50+am);

        ecpink = new Button("", 1);
        ecpink.setButtonColor(Color.PINK);
        ecpink.setFrameColor(Color.WHITE);
        addObject(ecpink, (int)(getWidth()/4.0*3)+125, (int)(getHeight()/2.0)+50+am);

        ecpurple = new Button("", 1);
        ecpurple.setButtonColor(Color.MAGENTA);
        ecpurple.setFrameColor(Color.WHITE);
        addObject(ecpurple, (int)(getWidth()/4.0*3)-125, (int)(getHeight()/2.0)+50+am);

        ecwhite = new Button("", 1);
        ecwhite.setButtonColor(Color.WHITE);
        ecwhite.setFrameColor(Color.WHITE);
        addObject(ecwhite, (int)(getWidth()/4.0*3)+175, (int)(getHeight()/2.0)+50+am);

        ecyellow = new Button("", 1);
        ecyellow.setButtonColor(Color.YELLOW);
        ecyellow.setFrameColor(Color.WHITE);
        addObject(ecyellow, (int)(getWidth()/4.0*3)-175, (int)(getHeight()/2.0)+50+am);
    }
    /**
     * Add Buttons for Spaceship projectile color selections
     */
    public void projectileColor() {
        if (Settings.Language.equals("en")) {
            Label pc = new Label("Projectile Color:", 40);
            addObject(pc, (int)(getWidth()/4.0*3), (int)((getHeight()/3.0)*2)+am);
        } else if (Settings.Language.equals("de")) {
            Label pc = new Label("Projektilfarbe:", 40);
            addObject(pc, (int)(getWidth()/4.0*3), (int)((getHeight()/3.0)*2)+am);
        }

        // Spaceship projectiles (Green, Pink, Red, Yellow, Orange, Purple)
        pcred = new Button("", 1);
        pcred.setButtonColor(Color.RED);
        pcred.setFrameColor(Color.WHITE);
        addObject(pcred, (int)(getWidth()/4.0*3)+25, (int)((getHeight()/3.0)*2)+50+am);

        pcorange = new Button("", 1);
        pcorange.setButtonColor(Color.ORANGE);
        pcorange.setFrameColor(Color.WHITE);
        addObject(pcorange, (int)(getWidth()/4.0*3)-25, (int)((getHeight()/3.0)*2)+50+am);

        pcgreen = new Button("", 1);
        pcgreen.setButtonColor(Color.GREEN);
        pcgreen.setFrameColor(Color.WHITE);
        addObject(pcgreen, (int)(getWidth()/4.0*3)+75, (int)((getHeight()/3.0)*2)+50+am);

        pcpurple = new Button("", 1);
        pcpurple.setButtonColor(Color.MAGENTA);
        pcpurple.setFrameColor(Color.WHITE);
        addObject(pcpurple, (int)(getWidth()/4.0*3)-75, (int)((getHeight()/3.0)*2)+50+am);

        pcpink = new Button("", 1);
        pcpink.setButtonColor(Color.CYAN);
        pcpink.setFrameColor(Color.WHITE);
        addObject(pcpink, (int)(getWidth()/4.0*3)+125, (int)((getHeight()/3.0)*2)+50+am);

        pcyellow = new Button("", 1);
        pcyellow.setButtonColor(Color.YELLOW);
        pcyellow.setFrameColor(Color.WHITE);
        addObject(pcyellow, (int)(getWidth()/4.0*3)-125, (int)((getHeight()/3.0)*2)+50+am);
    }
}
